=== debian/changelog ===
rock-master-19.06-planning-fd-uniform (0.20181206-1~stretch) unstable; urgency=low

  * Package automatically built using 'apaka'
  * repository: github:/rock-planning/planning-fd_uniform.git
  * branch: refs/heads/master
  * commit: 7a6a1d26577eb991dd57b4745f4e7b26429c49b9
  * tag: 

 -- Packaging Daemon <rock-dev@dfki.de>  Mon, 08 Jul 2019 16:04:29 +0200
