=== debian/control ===
Source: rock-master-19.06-planning-fd-uniform
Section: science
Priority: extra
Maintainer: Rock Packaging Daemon <rock-dev@dfki.de>
Build-Depends: cdbs, debhelper (>= 8.0.0), pkg-config, dh-autoreconf, build-essential, cmake, coinor-cbc, coinor-clp, coinor-libcbc-dev, coinor-libclp-dev, coinor-libcoinutils-dev, coinor-libosi-dev, libbz2-dev, pypy, python-dev, rock-master-19.06-base-cmake, zlib1g-dev
Standards-Version: 3.9.2
Homepage: http://rock-robotics.org
#Vcs-Git: git://git.debian.org/collab-maint/bla.git
#Vcs-Browser: http://git.debian.org/?p=collab-maint/bla.git;a=summary

Package: rock-master-19.06-planning-fd-uniform
Architecture: any
Depends: ${shlibs:Depends}, rock-master-19.06-base-cmake, cmake, build-essential, coinor-libcoinutils-dev, coinor-libosi-dev, coinor-clp, coinor-libclp-dev, coinor-cbc, coinor-libcbc-dev, python-dev, libbz2-dev, zlib1g-dev, pypy
Description: FastDownward Uniform base planner
 This in an integration package for the FastDownward Uniform planner as of IPC-2014 planners data (see url below).
  No additional functionality is provided, adaptations to the original source are made only to include the planner into the
  build infrastructure.
